# -*- coding: utf-8 -*-

# (C) Djordjevic Nebojsa <nesh@studioquattro.co.yu> 2005
# You're welcome to redistribute this software under the
# terms of the GNU Library General Public Licence version 2.0
# or, at your option, any higher version.
#
# You can read the complete GNU LGPL in the file COPYING
# which should come along with this software, or visit
# the Free Software Foundation's WEB site http://www.fsf.org
#

""" i18n support
"""

##################################################
## DEPENDENCIES ##

from i18n import *
# TODO
#from l10n import *

##################################################
## CLASSES ##

class Language(object):
    def __init__(self, language=None, domain=None, path=None):
        self.language = language
        self.domain = domain
        self.path = path
        self.locales = available_locales(path)
        self.translation = None

        # load translation
        old = get_translation() # save old
        try:
            set_language(self.language, self.domain, self.path)
            self.translation = get_translation()
        finally:
            set_translation(old) # restore old trans
    # __init__

    def gettext(self, message):
        """ Do translation of the given string into current language

            returns: unicode string with translated message
        """
        if (s == '') or (s is None):
            return u''

        frame = sys._getframe(1)
        dict = SafeDict(frame.f_locals)
        dict.update(frame.f_locals)

        tns = self.translation.ugettext(s)
        return tns % dict
    #

    def ngettext(self, singular, plural, n):
        frame = sys._getframe(1)
        dict = SafeDict(frame.f_locals)
        #dict.update(frame.f_locals)

        tns = self.translation.ungettext(singular, plural, n)
    
        return tns % dict
    #
# Language
